(defpackage :ironclad
  (:use :cl)
  (:nicknames :crypto)
  (:export
   ;; hash functions
   #:digest-sequence #:digest-stream #:digest-file
   #:make-digest #:copy-digest #:update-digest #:produce-digest

   ;; HMACs
   #:make-hmac #:update-hmac #:hmac-digest

   ;; introspection
   #:cipher-supported-p #:list-all-ciphers
   #:digest-supported-p #:list-all-digests
   #:mode-supported-p #:list-all-modes
   #:block-length #:digest-length

   ;; high-level operators
   #:make-cipher #:encrypt #:decrypt

   ;; classes
   #:aes-context #:square-context #:blowfish-context #:idea-context
   #:twofish-context
   #:des-context #:cast5-context #:tea-context #:xtea-context

   ;; conditions
   #:ironclad-error #:initialization-vector-not-supplied
   #:invalid-initialization-vector #:invalid-key-length))